#
# PAK Populating, formerly known as PAK ADDER
#

# routine to pick an element at random from a list
proc pickrandom { somelist } {
	set len [llength $somelist]
	set index [expr int([expr rand() * $len])]
	#printout "choosing number $index from list of len $len ($somelist)"
	return [lindex $somelist $index]
}

# try and find a random place for an objective 
# should be with the given range of the x/y given.
proc FindRandomObjPlace { x y range } {
# pick some random place within range.
	for  { set i 1 }  {$i < 50} {incr i 1} {
		set newx [expr $x + round([expr rand() * $range - $range / 2])]
		set newy [expr $y + round([expr rand() * $range - $range / 2])]
		if { [objective at $newx $newy] == -1} {
# found somewhere
			return "$newx $newy"
		}
	}
	return "$x $y" # give up
}

proc AddObjective { pak range prio name olist } {
		# creating objective site
		set newid [objective create [pickrandom $olist] ]
		# ust be a better way to do these next 3 lines...
		set xypos [FindRandomObjPlace [objective get $pak x] [objective get $pak y] $range]
		set newx [lindex $xypos 0]
		set newy [lindex $xypos 1]
		objective set $newid x $newx y $newy
		objective set $newid owner [objective get $pak owner] control [objective get $pak control]
		objective set $newid priority $prio parent $pak
# new objectives are given unique campids.
#		objective set $newid campid [objective get $newid id]
		printout "Added $name site to " [objective name $pak] " at $newx, $newy"
		return $newid
}

set samlist [objective type 31] 
#printout "samlist $samlist"
set armylist [objective type 3] 
#printout "armylist $armylist"
set depot [objective type 10] 
#printout "depot $depot"
set headquarters [objective type 9]
#printout "headquarters $headquarters"
set radars [objective type 21] 
#printout "radars $radars"

set added 0
set olist [lsort -real [objective list]]
foreach paks $olist {
	if {[objective get $paks priority] > 80} {

		AddObjective $paks 20 30 "Sam" $samlist
		AddObjective $paks 20 40 "Army" $armylist
		AddObjective $paks 20 30 "Depot" $depot
		AddObjective $paks 20 40 "HQ" $headquarters
		AddObjective $paks 20 30 "Radar" $radars
		incr added 5
	}
}

printout "We've added $added new objectives to the PAK"
printout "Thank you for using PMC PAK Populating script"
printout "featured in Julian Codec Onions fabulous Tacedit!"



# SAM Site's
# Ocd Id - Sub Type
# -------------------
# 887  - SAM Site
# 1690 - 24E SAM Site
# 1694 - D4F SAM Site
# 1695 - D4E SAM Site
# 1696 - A4F SAM Site
# 1697 - A4E SAM Site


# Army Base's
# Ocd Id - Sub Type
# -------------------
# 2089 - 142 ARMB
# 1684 - 251 ArmyBase
# 1681 - 252 Army Base
# 2090 - A0F ARMB
# 2091 - A35ARMB
# 1685 - A51 Army Base
# 1680 - A52 Army Base
# 1908 - Army Base
# 1904 - Army Base
# 1902 - Armybase
# 227  - Armybase 1
# 2087 - C0F ARMB
# 2088 - D39 ARMB
# 1688 - D51 Army Base
# 1686 - D52 Army Base
# 2378 - Refugee Camp 1
# 2379 - Refugee Camp 2
# 2462 - Terrorist Camp 1
# 2463 - Terrorist Camp 2
# 2464 - Terrorist Camp 3


# Depot's
# Ocd Id - Sub Type
# -------------------
# 2104 - 125DEPOT
# 2105 - 126DEPOT
# 2106 - 12DDEPOT
# 2092 - 322DEPOT
# 2093 - 402DEPOT
# 2094 - 40CDEPOT
# 2095 - 84BDEPOT
# 2108 - A35 DEPOT
# 2109 - A3BDEPOT
# 2097 - D31DEPOT
# 2099 - D36DEPOT
# 2102 - D3CDEPOT
# 2103 - D79DEPOT
# 1903 - Depot
# 1905 - Depot
# 871  - Depot
# 233  - Depot 1
# 2096 - ECADEPOT


# Headquarters's
# Ocd Id - Sub Type
# -------------------
# 2112 - 14CHQ
# 2110 - D35 HQ
# 2111 - D5AHQ
# 232  - Headquarters


# Radar Station's
# Ocd Id - Sub Type
# -------------------
# 2117 - 20FRADAR
# 2119 - 21BRADAR
# 2122 - 21CRADAR
# 2123 - 2DFRADAR
# 2126 - A34 RADAR
# 2127 - A3E RADAR
# 2128 - BA2RADAR
# 2129 - BA7RADAR
# 2130 - BCFRADAR
# 2114 - D35RADAR
# 2115 - D3ARADAR
# 2116 - D48RADAR
# 2131 - DA9RADAR
# 2124 - F00RADAR
# 2125 - F0FRADAR
# 2113 - FEFRADAR
# 242  - Radar Site 1


# Radio Tower's
# Ocd Id - Sub Type
# -------------------
# 662  - Radio Tower 1



#set j [expr {int(rand()*$n)}]


# The objective command has several variants, based on the first argument. 
#
# list - builds a TCL list containing all the objective IDs. 
#
# set ID field value ... - sets in the given objective ID the given 
# fields to the values. A list of the valid fields is given below. 
#
# get ID field ... - retrieves in a list the given fields. 
#
# create TYPE - creates a new objective of the given type. 
# Values should then be initialised with a set command. 
#
# delete ID - the objective is deleted. 
#
# type [value] - returns a list of the objective-type numbers for 
# all objectives or just those with type field. 
#
# at X Y - returns the ID of the objective at that location, or -1 if none

# Objective fields
# ----------------
# Type - the CT Id 
# Id - the objective ID 
# X - X location 
# Y - Y location 
# Z - elevation 
# SpotTime - last time this was spotted 
# spotted - spotted flags 
# bflags - basic flags 
# Control - which teams controls this 
# CampId - campaign id 
# lastrep - ?? 
# Flags - flags 
# Supply - supply status 
# Fuel - fuel status 
# Losses - losses 
# FCount - feature count 
# Priority - priority of the ibjective 
# Name - number index into the name table 
# Parent - parent id 
# Owner - owner of the objective 
# Nlinks - how many links it has 
# HasRadar - true if it has radar 
