# Test TCL
printout hello world

proc pickrandom { somelist } {
	set len [llength $somelist]
	set index [expr round([expr rand() * $len])]
	printout "choosing number $index from list of len $len ($somelist)"
	return [lindex $somelist $index]
}

printout "Objective 4 has priority/campid " [objective get 4 priority campid ]
printout "Name is " [objective name 4]
set name [campaign id2name 22]
printout "Theater name 22 is $name"
printout "Theater id $name is " [campaign name2id $name]
set name [campaign id2name 10]
printout "Theater name 10 is $name"
printout "Theater id $name is " [campaign name2id $name]
# create a brand (vain) new name
set name_new [campaign name2id -create Julian]
printout "Theater name $name_new is " [campaign id2name $name_new]

printout "List of unit types that are squadrons " [unit type squadron]
printout "List of unit types that are airlift squadrons " [unit type squadron 1]

# sort into ascending order a list of objectives
set olist [lsort -integer [objective list]]
printout "Pick one " [pickrandom $olist]
printout "Objective list $olist"
printout "Objectives of type 1540 " [lsort -integer [objective list [list 1540]]]
printout "Objectives of type 1540 or 1073 " [lsort -integer [objective list [list 1540 1073]]]
set obj1 [lindex $olist 0]
set x1 [objective get $obj1 x] 
set y1 [objective get $obj1 y]
printout "At $x1,$y1 is " [objective at $x1 $y1]

set newid [objective create 235]
printout "Created new objective $newid"
objective set $newid type 235 id $newid X 50 Y 50 Z 20 spottime 1 spotted 0x20 bflags 1 
objective set $newid control 2 lastrep 1 flags 0x1 supply 100 fuel 100 losses 1 
objective set $newid priority 11 name 1 parent 99 owner 5 nlinks 0 hasradar 1
#objective delete $newid
printout "deleted it again..."

set ulist [lsort -integer [unit list batallion]]
printout "Batallions are $ulist"
set ulist [lsort -integer [unit list batallion [list 179]]]
printout "Batallions type 179 are $ulist"

# print a list of squadrons
foreach uid [lsort -integer [unit list squadron]] {
	printout "Squadron $uid is at " [unit get $uid x] "," [unit get $uid y]
}
set unitvars    { Type Id X Y Z SpotTime spotted bflags Control CampId Name
	LastTime roster UnitFlags DestX DestY TargetId CargoId Moved Losses Tactic CurWp
	Reinf }
printout "Objectives of type town " [objective type 28]
set squadlist [unit list squadron ]
if { [ llength $squadlist ] > 0 } {
	set squad1 [lindex $squadlist 0]
	printout "Squadron 1 is $squad1" 
	foreach var { fuel speciality airbaseid hotspot aakills agkills ankills askills
				missionsflown missionscore totalloss } {
		printout "Squad $squad1 has $var of " [unit squadron get $squad1 $var]
	}
} else { printout "No squadrons present" }

set briglist [unit list brigade]
if { [llength $briglist] > 0} {
	set brig1 [lindex $briglist 0]
	printout "Brigade is $brig1"
	foreach var [ concat $unitvars { orders division aobj nunits unit1 unit2 unit3 unit4 unit5 } ] {
		printout "Brigade $brig1 has $var of " [unit brigade get $brig1 $var]
	}
} { 
	printout "No brigades present"
}

set batt1 [lindex [unit list batallion] 0]
printout "Batallion is $batt1"
foreach var { orders division aobj lastmove lastfight parent lastobj supply fatigue morale heading finalheading position } {
	printout "Batallion $batt1 has $var of " [unit batallion get $batt1 $var]
}
set navy1 [lindex [unit list navy] 0]
printout "Navy is $navy1"
foreach var { orders supply } {
	printout "Navy $navy1 has $var of " [unit navy get $navy1 $var]
}
set flightlist [lindex [unit list flight] 0]
if { [llength $flightlist ] > 0 } {
	set flight1 [lindex $flightlist 0]
	printout "Flight is $flight1"
	foreach var { alt fuelused lastmove lastcombat tot missiontime target nloads mission
			oldmission  lastdir  priority missionid evalflag missioncontext package squad
		requestor  package  lastplayer callsignId callsignNo refuel } {
		printout "Flight $flight1 has $var of " [unit flight get $flight1 $var]
	}
} else { printout "No flights present" }
set packlist [unit list package]
if {[llength $packlist] > 0} {
	set package1 [lindex $packlist 0]
	printout "Package is $package1"
	foreach var { nunits unit1 unit2 unit3 unit4 unit5 intercept awacs jstar ecm tanker
		wtcycle flights waitfor iax iay eax eay bpx bpy tpx tpy takeoff tptime pflags caps
		requests responses  nwpts nwpts2 } {
		printout "Package $package1 has $var of " [unit package get $package1 $var]
	}
} else { printout "No packages present" }

printout "Team 2 has " [team 2 get nmissions] " missions currently"
set nnewmr [ team 2 newmission tx 5 ty 6 mission 5] 
printout "Added new mission $nnewmr to team 2"
team 2 deletemission $nnewmr
printout removed it again
foreach var { requesterId targetId secondaryId pakId who vs tot tx ty flags
	caps targetNum speed matchStrength priority TotType ActionType mission
	aircraft context roeCheck delayed startBlock finalBlock slot0 slot1 slot2
	slot3 minTo maxTo } {
    printout "Mission request 1 field $var is " [team 2 getmission 1 $var]
}

foreach var { id type who team flags nmissions name description 
	initiative supplyavailable fuelavailable replaceavailable playerrating} {
	printout "Team 2 has field $var of " [team 2 get $var]
}
printout done
